
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL Server 优化---为什么索引视图（物化视图）需要with(noexpand)强制查询提示 / iVAN</title>

    <meta name="description" content="SQL Server 优化---为什么索引视图（物化视图）需要with(noexpand)强制查询提示 原文:SQL Server 优化---为什么索引视图(物化视图)需要with(noexpand)强制查询提示   本文出处:http://www.cnblogs.com/wy123/p/6694933.html    第一次通过索引视图优化SQL语句,以及遇到的一些问题,记录一下.   语句分析 最近开发递交过来一个查询统计的SQL,说是性能有问题,原本执行需要4-5秒钟,这个业务本身对性能要求又比较critical,期望是在1s之内在用尽各种办法之后(执行计划,统计信息,索引,改写SQL,临时">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">SQL Server 优化---为什么索引视图（物化视图）需要with(noexpand)强制查询提示</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/wy123/p/6694933.html" rel="external nofollow noreferrer">SQL Server 优化---为什么索引视图（物化视图）需要with(noexpand)强制查询提示</a><br />
<br /> </p>
<p>本文出处：<a href="http://www.cnblogs.com/wy123/p/6694933.html" rel="external nofollow noreferrer">http://www.cnblogs.com/wy123/p/6694933.html</a> </p>
<p> </p>
<p>第一次通过索引视图优化SQL语句，以及遇到的一些问题，记录一下。</p>
<p> </p>
<p><strong>语句分析</strong></p>
<p>最近开发递交过来一个查询统计的SQL，说是性能有问题，原本执行需要4-5秒钟，这个业务本身对性能要求又比较critical，期望是在1s之内<br />在用尽各种办法之后（执行计划，统计信息，索引，改写SQL，临时表拆分），依然没有实质性的改观，<br />在观察SQL本身的特点之后，<br />有以下几个特点<br />　　1，查询语句整体为多表join，但是每个表自身的数据并不是非常大，百万级<br />　　2，查询结果在主表上一个较大的时间范围的数据进行Count的聚合操作<br />　　3，几张表之间除了连接条件，主要是进行了一些比较复杂的逻辑运算（下面截图可以看到，没多少IO，CPU时间却很高）<br />   　　　 不过表的连接方式都是inner join，主要性能点就在于表关联之间的Hash join之间的逻辑运算，参考下图（是执行计划的一部分）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iYzdhM2ZlMzFjZGRiMmIzNDk4NGRiM2Y2NTVkODZmZi5wbmc=.jpg"></p>
<p>　　通过统计信息发现，该SQL语句的物理IO并不高,说明索引没有什么问题，通过索引改善IO可能改善空间很有限<br />　　时间主要花费在SQL语句的编译和的Hash join 运算<br />　　尝试改写借助SQL之后（纯改写SQL和借助临时表拆分语句），发现依然很难绕过Hash join，主要是表之间的逻辑运算最为耗时<br />　　最后想到可以先将运算好的的数据物理存储起来，然后改写查询的SQL语句完成等价的查询，<br />   　　避免每次查询都做复杂的逻辑运算，应该可以有比较大的改善，于是就想到了索引视图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181YjAxNGM0NzQ3NzEyZmYwNTZhM2I3MjQyYmVkMmZjOC5wbmc=.jpg"></p>
<p>　　</p>
<p><strong>创建索引视图改写SQL</strong></p>
<p>　　在提取出来原始的查询SQL，创建索引视图，并在索引视图上创建unique cluster index和合理的nocluster index<br />　　通过索引视图改写原始的查询统计SQL语句，<br />　　改写后的SQL语句是一个索引视图替代原始的4张表，与另外一个物理表join，发现效率上没有任何改善，<br />　　观察改写后的SQL语句的执行计划，发现跟原始SQL一样，并没有走索引视图上的索引，或者说是用到索引视图，一时间觉得好心塞，实在没招了<br />　　执行计划依旧是长长的一大段，然后依旧是好几个Hash Join.参考下图，执行计划跟本文第一个截图一模一样</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zYzNkNzY0Y2FjNTIxNDg1ZGQ2MmQ1MTQ4NzQ4Njk0Yi5wbmc=.jpg"></p>
<p>　　按道理，索引视图固化结果集，并且根据情况做了过滤，结果集是原始查询的一部分而已，<br />　　用同样的查询条件从索引视图做查询统计，走索引视图代价肯定要比原始SQL低，通过强制不展开with(noexpand)提示，证实了这个推断<br />　　如下是强制不展开索引视图的统计信息，可以看到完全达到了预期的1S之内</p>
<p>　　<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19jMzg3N2UwYjQ2ZTFlMzlkMWZiN2RlZDY4YTk3ODExOC5wbmc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19mZTE5ZjE3ZTY1MzU3Nzk5NDQ0Y2I5NGJjODM4MWQ4OC5wbmc=.jpg"></p>
<p> </p>
<p>　　当然索引视图也不是没有代价，在一定程度上牺牲了数据写入的效率和冗余存储，来换取查询的效率<br />　　之前简单介绍过索引视图的一些特点 <a href="http://www.cnblogs.com/wy123/p/6041122.html" rel="external nofollow noreferrer">http://www.cnblogs.com/wy123/p/6041122.html</a></p>
<p> </p>
<p><strong>索引视图被展开(expand)的原因分析</strong></p>
<p>　　最关键的问题在于，没有强制不展开索引视图（with(noexpand)提示）的情况下，为什么没有走索引视图呢？</p>
<p>　　这个问题确实郁闷了一阵子，整个半天都在想这个问题，因为索引视图本身用的就少，出现此问题更是一头雾水，不过Google一下，还有一大把类似的问题<br />　　如下是在google的时候查到的，原文是英文，大概意思如下，非直译。</p>
<p>　　参考链接：<a href="http://dba.stackexchange.com/questions/26979/what-factors-go-into-an-indexed-views-clustered-index-being-selected/27039#27039" rel="external nofollow noreferrer">http://dba.stackexchange.com/questions/26979/what-factors-go-into-an-indexed-views-clustered-index-being-selected/27039#27039</a></p>
<p>索引视图的匹配（查询用索引视图替代而不走原始的基础表）是一个相当昂贵的操作，因此优化器试图通过其他方式快速转换（生成执行计划）<br />如果优化器产生了一个相对优化的执行计划，就可以尽早结束（不必继续生成其他执行计划）<br />问题就在于：继续生成其他执行计划的代价要大于已生成的执行计划的代价<br />听起来有点别扭，<br />之前举过这么一个例子，比如说是花3秒钟找到一个相对优化的执行计划，这个执行计划完成SQL的执行需要2秒钟<br />与花10秒钟的时候找到一个最优化的执行计划，尽管这个执行计划完成SQL的执行可能只需要0.5秒钟，虽然后者的执行计划更优，但整体代价更大<br />优化器的主要目标是尽快找到一个足够好的执行计划（而非总是生成最好的执行计划）</p>
<p>使用索引视图本身并不是一个昂贵的操作，<br />但是与潜在索引视图中匹配逻辑查询树确实一个代价较大的行为，在查询涉及的视图在优化器优化之前已经被展开<br />因此优化器并不知道你的查询是否未被了索引视图，他看到的只是展开的查询树<br />这个通俗地讲就是：<br />让sqlserver知道，一个查询，可以用索引视图中的结果等价替代视图逻辑中原始的基表，是一个代价较大的过程<br />因为SQL Server根据原始的基础表，生成一种执行计划之后，就不去判断是否可以用索引视图做等价替代。</p>
<p> 　　当然白皮书里有更详细的介绍，里面索引视图相关的一些逻辑实现和分析<a href="http://www.cs.cmu.edu/~natassa/courses/15-823/current/papers/vldb00.pdf" rel="external nofollow noreferrer">http://www.cs.cmu.edu/~natassa/courses/15-823/current/papers/vldb00.pdf</a></p>
<p> </p>
<p>最后多逼逼一句：<br />　　上面的白皮书实在看不懂，只是Google出来说详细信息请看这个参考资料,<br />　　这里只是从现象去推断优化器在面对索引视图的一些特性，了解到内在机制的一些特点，可能潜在的问题，以及对应的解决办法<br />　　这里又提开源软件了，别说不开源了，即便是开源了，除了钱的因素，在技术上，有几个人可以动一下这些大型软件的核心代码？<br />   　　我并不是在黑开源软件啊，只是听有人说，开源好啊，有源码怎么怎么样，觉得够装13的，<br />   　　国内除了bat等少数几家公司做过修改源码，做过开源数据库的定制，试问还有多少家可以修改数据库源码然后上生产使用</p>
<p>　　最近在学MySQL，继续SQL Server下去恐怕踏马要失业了，开源，对大多数公司来说，钱才是一个大头因素吧，尼玛跑题了。</p>
<p> 　　</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:44:35</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/hash/" title="hash">hash</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>SQL Server 优化---为什么索引视图（物化视图）需要with(noexpand)强制查询提示的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwyYlEM.html" rel="bookmark">Sql Server优化之索引提示----我们为什么需要查询提示，Sql Server默认情况下优化策略选择的不足</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Sql Server优化之索引提示----我们为什么需要查询提示,Sql Server默认情况下优化策略选择的不足 环境: Sql Server2012 SP3企业版,Windows Server2008 标准版   问题由来: 最近在做DB优化的时候,发现一个存储过程有非常严重的性能问题, 由于整个SP整体逻辑是一个多表关联的复杂的查询,整体结构比较复杂的,通过的分析和尝试, 最后发现问题出在其中一个大表的查询上实现方式上, 因为这个大表上的意外的执行方式,导致其他表无法被驱动,其他表也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wANjp.html" rel="bookmark">Sql server优化其索引的小技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于索引的常识:影响到数据库性能的最大因素就是索引.由于该问题的复杂性,我只可能简单的谈谈这个问题,不过关于这方面的问题,目前有好几本不错的书籍可供你参阅.我在这里只讨论两种SQL Server索引,即clustered索引和nonclustered索引.当考察建立什么类型的索引时,你应当考虑数据类型和保存这些数据的column.同样,你也必须考虑数据库可能用到的查询类型以及使用的最为频繁的查询类型. 索引的类型 如果column保存了高度相关的数据,并且常常被顺序访问时,最好使用cluster			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRw0ykp.html" rel="bookmark">八大案例，带你参透SQL Server优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本文中,石沫针对用户遇到的各种实际问题,从实例层次到架构,通过8个SQL Server优化案例,分享了如何用最简单快捷的方式解决用户使用SQL Server数据库过程中的典型问题,使SQL Server能够稳定地提供持续服务. 以下是整理内容. 瓶颈诊断 工欲善其事,必先利其器.常见的分析性能问题的工具有三种:诊断硬件资源,等待类型,性能语句. 硬件资源通常有四个方面判断: CPU监控,性能计数器主要包括%Processor Time.Processor Queue Length.Batch			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDYjBz.html" rel="bookmark">SQL Server基础之&amp;lt&semi;索引&amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server基础之&lt;索引&gt;  索引用于快速找出在某个列中有某一特定值的行,不使用索引,数据库必须从第一条记录开始读完整个表,直到找出相关的行.表越大,查询数据所花费的时间越多,如果表中查询的列有一个索引,数据库能快速到达一个位置去搜索数据,本篇主要介绍与索引相关的内容,包括索引的含义和特点,索引的分类,索引的设计原则以及如何创建和删除索引. 一:索引的含义和特点  索引是一个单独的,存储在磁盘上的数据结构,它们包含则对数据表里所有记录的引用指针,使用索引用于快速找出在某个或多个列			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKEvrz.html" rel="bookmark">&lbrack;SQL Server优化&rsqb;善用系统监视器，确定系统瓶颈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[SQL Server优化]善用系统监视器,确定系统瓶颈 来自: http://hi.baidu.com/solorez/blog/item/f82038fa0e71b78d9e51468c.html 如果您运行的是 Microsoft Windows 服务器操作系统,则可以使用系统监视器图形工具来测量系统当前的性能参数.可以查看包括处理器.内存.缓存.线程和进程等数据.每个对象都有一个相关的的计数器集,用于测量设备使用情况.队列长 度.延时情况,另外还有吞吐量及内部拥塞指示器. 监视磁盘			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXN1gAb.html" rel="bookmark">SQL Server 深入解析索引存储&lpar;中&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server 深入解析索引存储(中) 标签:SQL SERVER/MSSQL SERVER/数据库/DBA/索引体系结构/堆 概述      本篇文章是关于堆的存储结构.堆是不含聚集索引的表(所以只有非聚集索引的表也是堆).堆的 sys.partitions 中具有一行,对于堆使用的每个分区,都有 index_id = 0.默认情况下,一个堆有一个分区.当堆有多个分区时,每个分区有一个堆结构,其中包含该特定分区的数据.例如,如果一个堆有四个分区,则有四个堆结构:每个分区有一个堆结构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6qjJob.html" rel="bookmark">SQL Server 深入解析索引存储&lpar;下&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server 深入解析索引存储(下)   标签:SQL SERVER/MSSQL SERVER/数据库/DBA/索引体系结构/非聚集索引 概述   非聚集索引与聚集索引具有相同的 B 树结构,它们之间的显著差别在于以下两点: 基础表的数据行不按非聚集键的顺序排序和存储. 非聚集索引的叶层是由索引页而不是由数据页组成. 既可以使用聚集索引来为表或视图定义非聚集索引,也可以根据堆来定义非聚集索引.非聚集索引中的每个索引行都包含非聚集键值和行定位符.此定位符指向聚集索引或堆中包含该键值的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjExZ6z.html" rel="bookmark">SQL Server 优化器特性导致的内存授予相关BUG</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server 优化器特性导致的内存授予相关BUG 我们有时会遇到一些坑,要不填平,要不绕过.这里为大家介绍一个相关SQL Server优化器方面的特性导致内存授予的相关BUG,及相关解决方式,也顺便回答下邹建同学的相关疑问.   问题描述 一个简单的查询消耗了匪夷所思的内存.(邹建同学发现的) 原文链接 Code create table test_mem ( id int identity(1,1) primary key, itemid int not null, date d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVNZ2Bz.html" rel="bookmark">SQLServer &CenterDot; 最佳实践 &CenterDot; SQL Server优化案例分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				title: SQLServer · 最佳实践 · SQL Server优化案例分享 author: 石沫 前端时间的视频分享,这里有同学文档总结下来: 请参考:https://yq.aliyun.com/articles/60119			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3r9kz.html" rel="bookmark" class="title">跟踪oracle中sql语句执行过程及相关知识拓展</a>
					<div>
						select * from v$sqlarea; select * from v$sqlarea where first_load_time&gt;'2010-11-27/09:30:00';     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0RyPz.html" rel="bookmark" class="title">C&num;二进制输出数据</a>
					<div>
						用ToString方法:    说明:Convert.ToString   方法   (Int16,   IFormatProvider)    用法:string   valueString   = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ1GGb.html" rel="bookmark" class="title">怎么样才可以让Form表单在加载的时候只自动提交一次？</a>
					<div>
						方案一:  使用body标签的onload方法提交form表单即可.    具体如下例: &lt;body onload=&quot;form.submit();&quot;&gt; &lt;form ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrQKxb.html" rel="bookmark" class="title">Dreamweaver网页制作教程：框架技术</a>
					<div>
						dreamweaver|教程|网页 框架技术 在浏览网页的时候,我们常常会遇到这样的一种导航结构.就是超级连接做在左边单击以后链接的目标出现在右面.或者在上边单击链接指向的目标页面出现在下面.要做出这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz74jdb.html" rel="bookmark" class="title">使用用于SQL Server的IIS虚拟目录管理实用工具</a>
					<div>
						iis|server|虚拟目录 在使用 HTTP 访问 Microsoft? SQL Server? 2000 数据库之前,必须安装适当的虚拟目录.在运行 Microsoft Internet 信息服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJLw8M.html" rel="bookmark" class="title">C&num;设计模式之抽象工厂&lpar;abstract factory&rpar;模式示例源代码</a>
					<div>
						设计|示例|源代码 using System; namespace Design_Pattern{  public class  Computer {  private RAM Ram;  priva ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPZQQM.html" rel="bookmark" class="title">Linux下清除系统日志的方法</a>
					<div>
						  代码如下: #!/bin/sh cat /dev/null &gt; /var/log/syslog cat /dev/null &gt; /var/adm/sylog cat /dev/null ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9ER2VM.html" rel="bookmark" class="title">为什么DP992连接电视半天都进不了界面？</a>
					<div>
						    DP992数码伴侣可以作为移动存储设备来使用,如果您将数据.视频.音频和图片文件同时一并放在硬盘中,这样就会影响DP992开机载入读取的时间.如果您有移动存储以及文件播放双重的需求,建议您格式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwGmxp.html" rel="bookmark" class="title">微营销在电脑维修行业中的应用</a>
					<div>
						  这段时间一直在学习微营销方面的知识,越学越能感到这玩意神通广大,昨天脑海里突然灵光一闪,如果用微营销做电脑维修效果怎样?于是本文就诞生了. 现在的电脑维修门店到处都是,一个高档小区可能就有3家左右 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqyrkb.html" rel="bookmark" class="title">自动刷新网页&comma;自动刷新当前页面&comma;JS调用&lowbar;javascript技巧</a>
					<div>
						reload 方法,该方法强迫浏览器刷新当前页面.语法:location.reload([bForceGet])                                             ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3w3lz.html" rel="bookmark" class="title">Silverlight&plus;WCF 实战-网络象棋最终篇之房间装修-WCF端&lpar;二&rpar;</a>
					<div>
						在线演示地址:Silverlight+WCF 新手实例 象棋 在线演示 上一系列四十篇索引:Silverlight+WCF 新手实例 象棋 专题索引   佛靠金装,人要衣裳,房间也要加金砖.本篇我们来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPryDp.html" rel="bookmark" class="title">图片-c语言问题</a>
					<div>
						问题描述 c语言问题 Write a program using the given functions 用给定函数编写程序Must use a structure type 必须使用结构类型 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3YNlz.html" rel="bookmark" class="title">求一个nexus私服下载地址，官网下载不了，总是找不到路径</a>
					<div>
						问题描述 求一个nexus私服下载地址,官网下载不了,总是找不到路径 http://www.sonatype.org/nexus/ 这个是私服下载的官网地址,但是点击下载的时候,就找不到链接了,哪个好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBREGM.html" rel="bookmark" class="title">&lbrack;WCF权限控制&rsqb;通过扩展自行实现服务授权&lbrack;提供源码下载&rsqb;</a>
					<div>
						其实针对安全主体的授权实现的原理很简单,原则上讲,只要你能在服务操作执行之前能够根据本认证的用户正确设置当前的安全主体就可以了.如果你了解WCF的整个运行时框架结构,你会马上想到用于授权的安全主体初始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXm11z.html" rel="bookmark" class="title">WPF 多个 MediaElement 播放总有一个无反应。</a>
					<div>
						问题描述 前台:&lt;Gridx:Name=&quot;main&quot;&gt;&lt;Grid.ColumnDefinitions&gt;&lt;ColumnDefinitionWidth=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLD7Np.html" rel="bookmark" class="title">关于webLucene 安装方法&lowbar;java</a>
					<div>
						1.运行javacc2_1这个类时需要注意类的路径,避免出现找不到主函数的错误,最直接的方法是把它放到java默认路径下运行 2.其中有两个类定义了变量enum,这在jdk高版本中是不允许的,需要手工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RBV3b.html" rel="bookmark" class="title">一些你可能没重视的外链实用经验</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 外链的质量和广度与网站在搜索引擎的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwW1qOz.html" rel="bookmark" class="title">免费&OpenCurlyDoubleQuote;工具&rdquo;的背后&mdash;&mdash;网络犯罪分子劫持黑客的阴谋</a>
					<div>
						本文讲的是免费&quot;工具&quot;的背后--网络犯罪分子劫持黑客的阴谋, 要知道,在这个世界上没有什么是免费的. 如果此刻您正在互联网上搜索免费的黑客工具,那么就需要注意,大多数能够免费提供的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXOYVz.html" rel="bookmark" class="title">《响应式Web设计实践》一1&period;7&emsp;这本书写给谁</a>
					<div>
						1.7 这本书写给谁 响应式Web设计实践 这本书本意上是为那些希望能在无尽的设备上创建出具有良好界面和功能的站点的设计师和开发者而写的.你不需要有任何响应式设计的经验--前面的几章会让你跟得上的.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL4Pdp.html" rel="bookmark" class="title">Dubbo 的商业化解决方案</a>
					<div>
						典型场景 1. 应用发布与管理 在云环境中,应用发布与管理会变得十分复杂.本地开发完成的应用需要登录到每一台服务器进行发布和部署:后续还会有应用的重启,扩容等.服务器的不断增加对于运维人员将是一个极大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1jwAz.html" rel="bookmark" class="title">15 个 Android 通用流行框架大全</a>
					<div>
						1. 缓存 DiskLruCache Java实现基于LRU的磁盘缓存 2.图片加载 Android Universal Image Loader 一个强大的加载,缓存,展示图片的库 Picasso  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A1DVz.html" rel="bookmark" class="title">OpenNMS 1&period;9&period;92发布 网络系统监控管理平台</a>
					<div>
						OpenNMS 1.9.92这个候选发行版包含了大量的bug修正,包括代码清理,用户界面​​更新,更多Linkd的运行,及一些http://www.aliyun.com/zixun/aggregati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBw0lz.html" rel="bookmark" class="title">C&num;编写WinForm，生成数字码并写入指定Excel（求指导哇）</a>
					<div>
						问题描述 Excel文件要求:文件名固定,有两个表单且表单名固定.表单用途:(跟下面的序列号生成规则结合起来,就不太会了--)数字码写入sheet1列&quot;A&quot;,每次写入均从第二行往下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnyN8M.html" rel="bookmark" class="title">支付宝关闭信用卡充值通道，为遏制用户信用卡套现</a>
					<div>
						从2月8日起,信用卡向支付宝账户充值的通道将关闭,而部分银行也于近日调高了信用卡支付的上限,以应对由此给用户带来的不便. 支付宝相关人士表示,关闭信用卡充值通道并不意味着在支付宝上禁用信用卡,用户仍可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRa4Zp.html" rel="bookmark" class="title">那位高手有WebService能跑起来的例子</a>
					<div>
						问题描述 那位高手有WebService能跑起来的例子 刚刚接触这个 那位仁兄 有能跑起来的 代码 给我参考下 谢谢啦 解决方案 请看看这篇博文,有什么不明白的可以问我.http://jadethao ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRNOop.html" rel="bookmark" class="title">南方都市报专栏：从公共网吧过渡到公共食堂</a>
					<div>
						邵建专栏 一位从事餐饮业的全国政协委员将在两会期间提交这样一份提案:关闭所有社会网吧,由政府出面办公共网吧.因为网吧衍生的各种社会问题,已经成了社会顽疾,针对顽疾,就应该下猛药. 这药够猛,按照这位委 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5QJkz.html" rel="bookmark" class="title">jconsole使用介绍&lpar;图文&rpar;&lowbar;java</a>
					<div>
						首先先看一下jvm的大致情况,包括:堆内存使用情况,加载的类的情况,线程个数等等信息.如下图所示: 接着看一下通过jconsole看到的jvm的内存使用情况.jvm主要管理两种类型的内存:堆和非堆.简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Qmvmp.html" rel="bookmark" class="title">jQuery中parent&lpar;&rpar;方法用法实例&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery中parent()方法用法.分享给大家供大家参考.具体分析如下: 此方法取得匹配元素集合中每个元素的紧邻父元素,也就是第一级父元素,而不是所有的祖先元素. 所取得的父元素集合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GmlNp.html" rel="bookmark" class="title">浅谈jQuery hover&lpar;over&comma; out&rpar;事件函数&lowbar;jquery</a>
					<div>
						hover(over, out)事件函数 当鼠标移动一个匹配的元素上面,会触发指定的第一个函数 当鼠标移出这个元素时,会触发指定的第二个函数 over(function):鼠标移到元素上触发的函数 o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEny6z.html" rel="bookmark" class="title">javascript jsetInterval实现计时器效果</a>
					<div>
						0时0分0秒00毫秒    					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
